<?php
namespace MASCOTCORENOVIO\Shortcodes\AnimatedLayerImages;

use MASCOTCORENOVIO\Shortcodes\Lib;

/**
 * class SC_Animated_Layer_Images
 * @package MASCOTCORENOVIO\Shortcodes\AnimatedLayerImages;
 */
class SC_Animated_Layer_Images implements Lib\Mascot_Core_Novio_Interface_Shortcodes {
	
	/**
	 * @var shortcode_base
	 */
	private $shortcode_base;

	/**
	 * construct
	 */
	public function __construct() {
		$this->shortcode_base = 'tm_animated_layer_images';
		add_action('init', array($this, 'MapShortCodeVC'), 998);
	}

	/**
	 * Returns shortcode_base for shortcode
	 */
	public function getShortCodeBase() {
		return $this->shortcode_base;
	}

	/**
	 * Maps shortcode to Visual Composer
	 */
	public function MapShortCodeVC() {
		$title_options = esc_html__( 'Title Options', 'mascot-core' );

		if(function_exists('vc_map')) {
			$vc_map = array(
				'name'		=> esc_html__( 'Animated Layer Images', 'mascot-core' ),
				'base'		=>$this->shortcode_base,
				'category'	=> esc_html__( 'by TM', 'mascot-core' ),
				'icon'		=> 'mascot-vc-icons vc-icon-animated-layer',
				'allowed_container_element' => 'vc_row',
				'params'	=>array(
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Custom CSS class of Parent Div", 'mascot-core' ),
						"param_name"	=> "custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),


					array(
						'type'			=> 'attach_image',
						"heading"		=> esc_html__( "First Image", 'mascot-core' ),
						"param_name"	=> "first_image",
						'save_always'   => true,
						'admin_label'   => true,
					),
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "First Image Size", 'mascot-core' ),
						"param_name"	=> "first_image_size",
						'description'   => '',
						'value'			=> mascot_core_novio_get_available_image_sizes_for_vc(),
						'std'			=> 'large',
					),
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "First Image Animation Effect", 'mascot-core' ),
						"param_name"	=> "first_image_animation_effect",
						'value'			=> mascot_core_novio_tm_custom_animation_class_list(),
						'save_always'   => true,
						'admin_label'   => true,
						'std'			=> 'move-up',
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "First Image Wrapper Custom CSS class", 'mascot-core' ),
						"param_name"	=> "first_image_wrapper_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "First Image Wrapper Custom Inline Style", 'mascot-core' ),
						"param_name"	=> "first_image_wrapper_inline_style",
						"description"	=> esc_html__( 'Example: top: 12px; left: 100px;', 'mascot-core' ),
						'admin_label'   => true,
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "First Image Custom CSS class", 'mascot-core' ),
						"param_name"	=> "first_image_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),




					array(
						'type'			=> 'attach_image',
						"heading"		=> esc_html__( "Second Image", 'mascot-core' ),
						"param_name"	=> "second_image",
						'save_always'   => true,
						'admin_label'   => true,
					),
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "Second Image Size", 'mascot-core' ),
						"param_name"	=> "second_image_size",
						'description'   => '',
						'value'			=> mascot_core_novio_get_available_image_sizes_for_vc(),
						'std'			=> 'large',
					),
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "Second Image Animation Effect", 'mascot-core' ),
						"param_name"	=> "second_image_animation_effect",
						'value'			=> mascot_core_novio_tm_custom_animation_class_list(),
						'save_always'   => true,
						'admin_label'   => true,
						'std'			=> 'move-up',
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Second Image Wrapper Custom CSS class", 'mascot-core' ),
						"param_name"	=> "second_image_wrapper_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Second Image Wrapper Custom Inline Style", 'mascot-core' ),
						"param_name"	=> "second_image_wrapper_inline_style",
						"description"	=> esc_html__( 'Example: top: 12px; left: 100px;', 'mascot-core' ),
						'admin_label'   => true,
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Second Image Custom CSS class", 'mascot-core' ),
						"param_name"	=> "second_image_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),


					array(
						'type'			=> 'attach_image',
						"heading"		=> esc_html__( "Third Image", 'mascot-core' ),
						"param_name"	=> "third_image",
						'save_always'   => true,
						'admin_label'   => true,
					),
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "Third Image Size", 'mascot-core' ),
						"param_name"	=> "third_image_size",
						'description'   => '',
						'value'			=> mascot_core_novio_get_available_image_sizes_for_vc(),
						'std'			=> 'large',
					),
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "Third Image Animation Effect", 'mascot-core' ),
						"param_name"	=> "third_image_animation_effect",
						'value'			=> mascot_core_novio_tm_custom_animation_class_list(),
						'save_always'   => true,
						'admin_label'   => true,
						'std'			=> 'move-up',
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Third Image Wrapper Custom CSS class", 'mascot-core' ),
						"param_name"	=> "third_image_wrapper_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Third Image Wrapper Custom Inline Style", 'mascot-core' ),
						"param_name"	=> "third_image_wrapper_inline_style",
						"description"	=> esc_html__( 'Example: top: 12px; left: 100px;', 'mascot-core' ),
						'admin_label'   => true,
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Third Image Custom CSS class", 'mascot-core' ),
						"param_name"	=> "third_image_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),
				)
			);
			vc_map( $vc_map );

			//Modify vc_map from themes
			if( function_exists('mascot_core_novio_sc_animated_layer_images_vc_map_modifier') ) {
				mascot_core_novio_sc_animated_layer_images_vc_map_modifier( $this->shortcode_base );
			}
		}
	}

	/**
	 * Renders shortcodes HTML
	 */
	public function render( $attr, $content = null ) {

		//Render Shortcode from themes
		if( function_exists('mascot_core_novio_sc_animated_layer_images_render') && function_exists('vc_map') ) {
			return mascot_core_novio_sc_animated_layer_images_render( $attr, $content );
		}
		
	}
}