<?php
namespace MASCOTCORENOVIO\Shortcodes;

use MASCOTCORENOVIO\Shortcodes\Lib;
use MASCOTCORENOVIO\Shortcodes\AnimatedLayerAdvanced\SC_Animated_Layer_Advanced;
use MASCOTCORENOVIO\Shortcodes\AnimatedLayerAdvancedItem\SC_Animated_Layer_Advanced_Item;
use MASCOTCORENOVIO\Shortcodes\AnimatedLayerAdvancedChildHolder\SC_Animated_Layer_Advanced_Child_Holder;
use MASCOTCORENOVIO\Shortcodes\AnimatedLayerImages\SC_Animated_Layer_Images;
use MASCOTCORENOVIO\Shortcodes\BeforeAfterSlider\SC_Before_After_Slider;
use MASCOTCORENOVIO\Shortcodes\Blockquote\SC_Blockquote;
use MASCOTCORENOVIO\Shortcodes\Blog\SC_Blog;
use MASCOTCORENOVIO\Shortcodes\Button\SC_Button;
use MASCOTCORENOVIO\Shortcodes\CallToAction\SC_Call_To_Action;
use MASCOTCORENOVIO\Shortcodes\CharitableCampaigns\SC_Charitable_Campaigns;
use MASCOTCORENOVIO\Shortcodes\CharitableCampaignCustom\SC_Charitable_Campaign_Custom;
use MASCOTCORENOVIO\Shortcodes\CountdownTimer\SC_Countdown_Timer;
use MASCOTCORENOVIO\Shortcodes\CustomColumnsHolder\SC_Custom_Columns_Holder;
use MASCOTCORENOVIO\Shortcodes\CustomColumnsHolderItem\SC_Custom_Columns_Holder_Item;
use MASCOTCORENOVIO\Shortcodes\FloatingObjects\SC_Floating_Objects;
use MASCOTCORENOVIO\Shortcodes\FunFactCounter\SC_FunFact_Counter;
use MASCOTCORENOVIO\Shortcodes\Dropcaps\SC_Dropcaps;
use MASCOTCORENOVIO\Shortcodes\FeaturesBox\SC_Features_Box;
use MASCOTCORENOVIO\Shortcodes\GiveCampaigns\SC_Give_Campaigns;
use MASCOTCORENOVIO\Shortcodes\GiveSingleFormCustom\SC_Give_Single_Form_Custom;
use MASCOTCORENOVIO\Shortcodes\GoogleMap\SC_Google_Map;
use MASCOTCORENOVIO\Shortcodes\IconBox\SC_Icon_Box;
use MASCOTCORENOVIO\Shortcodes\InfoBanner\SC_Info_Banner;
use MASCOTCORENOVIO\Shortcodes\InfoBannerAdvanced\SC_Info_Banner_Advanced;
use MASCOTCORENOVIO\Shortcodes\LearnPressListCourses\SC_LearnPress_List_Courses;
use MASCOTCORENOVIO\Shortcodes\LineWithText\SC_LineWithText;
use MASCOTCORENOVIO\Shortcodes\LocationMarker\SC_Location_Marker;
use MASCOTCORENOVIO\Shortcodes\NavTabsHolder\SC_Nav_Tabs_Holder;
use MASCOTCORENOVIO\Shortcodes\NavTabsHolderItem\SC_Nav_Tabs_Holder_Item;
use MASCOTCORENOVIO\Shortcodes\NavTabsPricing\SC_Nav_Tabs_Pricing;
use MASCOTCORENOVIO\Shortcodes\NavTabsPricingItem\SC_Nav_Tabs_Pricing_Item;
use MASCOTCORENOVIO\Shortcodes\OpeningHours\SC_Opening_Hours;
use MASCOTCORENOVIO\Shortcodes\OpeningHoursCompressed\SC_Opening_Hours_Compressed;
use MASCOTCORENOVIO\Shortcodes\ParollerAnimation\SC_Paroller_Animation;
use MASCOTCORENOVIO\Shortcodes\PaypalDonation\SC_Paypal_Donation;
use MASCOTCORENOVIO\Shortcodes\PieChart\SC_Pie_Chart;
use MASCOTCORENOVIO\Shortcodes\PricingTable\SC_PricingTable;
use MASCOTCORENOVIO\Shortcodes\ProgressBar\SC_Progress_Bar;
use MASCOTCORENOVIO\Shortcodes\ScreenshotGallery\SC_Screenshot_Gallery;
use MASCOTCORENOVIO\Shortcodes\SectionTitle\SC_Section_Title;
use MASCOTCORENOVIO\Shortcodes\SocialLinks\SC_Social_Links;
use MASCOTCORENOVIO\Shortcodes\TribeEvents\SC_Tribe_Events;
use MASCOTCORENOVIO\Shortcodes\VideoPopup\SC_Video_Popup;
use MASCOTCORENOVIO\Shortcodes\UnorderedList\SC_Unordered_List;
use MASCOTCORENOVIO\Shortcodes\WCProducts\SC_WC_Products;
use MASCOTCORENOVIO\Shortcodes\WorkingStepsHolder\SC_Working_Steps_Holder;
use MASCOTCORENOVIO\Shortcodes\WorkingStepsHolderItem\SC_Working_Steps_Holder_Item;

/**
 * class Loader_Shortcodes
 * @package MASCOTCORENOVIO\Shortcodes;
 */
class Loader_Shortcodes {
	/**
	 * @var Singleton The reference to *Singleton* instance of this class
	 */
	private static $instance;

	/**
	 * @var array
	 */
	private $allShortCodes = array();
	
	/**
	 * Returns the *Singleton* instance of this class.
	 *
	 * @return Singleton The *Singleton* instance.
	 */
	public static function get_instance()
	{
		if (null === static::$instance) {
			static::$instance = new static();
		}
		
		return static::$instance;
	}

	/**
	 * Protected constructor to prevent creating a new instance of the
	 * *Singleton* via the `new` operator from outside of this class.
	 */
	protected function __construct()
	{
	}

	/**
	 * Private clone method to prevent cloning of the instance of the
	 * *Singleton* instance.
	 *
	 * @return void
	 */
	private function __clone()
	{
	}

	/**
	 * Private unserialize method to prevent unserializing of the *Singleton*
	 * instance.
	 *
	 * @return void
	 */
	public function __wakeup()
	{
	}


	/**
	 * Adds new SC to SC array
	 */
	private function addNewShortCode(Lib\Mascot_Core_Novio_Interface_Shortcodes $newShortCode) {
		if(!array_key_exists($newShortCode->getShortCodeBase(), $this->allShortCodes)) {
			$this->allShortCodes[$newShortCode->getShortCodeBase()] = $newShortCode;
		}
	}

	/**
	 * List of all SCs to register
	 */
	private function available_shortcodes() {
		$this->addNewShortCode(new SC_Animated_Layer_Advanced());
		$this->addNewShortCode(new SC_Animated_Layer_Advanced_Item());
		$this->addNewShortCode(new SC_Animated_Layer_Advanced_Child_Holder());
		$this->addNewShortCode(new SC_Animated_Layer_Images());
		$this->addNewShortCode(new SC_Before_After_Slider());
		$this->addNewShortCode(new SC_Blockquote());
		$this->addNewShortCode(new SC_Blog());
		$this->addNewShortCode(new SC_Button());
		$this->addNewShortCode(new SC_Call_To_Action());
		$this->addNewShortCode(new SC_Charitable_Campaigns());
		$this->addNewShortCode(new SC_Charitable_Campaign_Custom());
		$this->addNewShortCode(new SC_Countdown_Timer());
		$this->addNewShortCode(new SC_Custom_Columns_Holder());
		$this->addNewShortCode(new SC_Custom_Columns_Holder_Item());
		$this->addNewShortCode(new SC_Dropcaps());
		$this->addNewShortCode(new SC_Features_Box());
		$this->addNewShortCode(new SC_Floating_Objects());
		$this->addNewShortCode(new SC_FunFact_Counter());
		$this->addNewShortCode(new SC_Give_Campaigns());
		$this->addNewShortCode(new SC_Give_Single_Form_Custom());
		$this->addNewShortCode(new SC_Google_Map());
		$this->addNewShortCode(new SC_Icon_Box());
		$this->addNewShortCode(new SC_Info_Banner());
		$this->addNewShortCode(new SC_Info_Banner_Advanced());
		$this->addNewShortCode(new SC_LearnPress_List_Courses());
		$this->addNewShortCode(new SC_LineWithText());
		$this->addNewShortCode(new SC_Location_Marker());
		$this->addNewShortCode(new SC_Nav_Tabs_Holder());
		$this->addNewShortCode(new SC_Nav_Tabs_Holder_Item());
		$this->addNewShortCode(new SC_Nav_Tabs_Pricing());
		$this->addNewShortCode(new SC_Nav_Tabs_Pricing_Item());
		$this->addNewShortCode(new SC_Opening_Hours());
		$this->addNewShortCode(new SC_Opening_Hours_Compressed());
		$this->addNewShortCode(new SC_Paroller_Animation());
		$this->addNewShortCode(new SC_Paypal_Donation());
		$this->addNewShortCode(new SC_Pie_Chart());
		$this->addNewShortCode(new SC_PricingTable());
		$this->addNewShortCode(new SC_Progress_Bar());
		$this->addNewShortCode(new SC_Screenshot_Gallery());
		$this->addNewShortCode(new SC_Section_Title());
		$this->addNewShortCode(new SC_Social_Links());
		$this->addNewShortCode(new SC_Tribe_Events());
		$this->addNewShortCode(new SC_Unordered_List());
		$this->addNewShortCode(new SC_Video_Popup());
		$this->addNewShortCode(new SC_WC_Products());
		$this->addNewShortCode(new SC_Working_Steps_Holder());
		$this->addNewShortCode(new SC_Working_Steps_Holder_Item());
	}


	/**
	 * Calls available_shortcodes method, loops through each SC in array and add it through add_shortcode
	 */
	public function load() {
		$this->available_shortcodes();
		foreach ($this->allShortCodes as $eachShortCode) {
			add_shortcode($eachShortCode->getShortCodeBase(), array($eachShortCode, 'render'));
		}
	}
}

//Create instance of Loader_Shortcodes
$scloader = Loader_Shortcodes::get_instance();
$scloader->load();